package ca.recrown.islandsurvivalcraft.interaction.commands;

import ca.recrown.islandsurvivalcraft.interaction.commands.runnables.HighlightIslandCommand;

import ca.recrown.islandsurvivalcraft.interaction.commands.runnables.*;

public enum RegisteredCommands {
    HIGHLIGHT(new HighlightIslandCommand()),
    HELP(new HelpCommand()),
    VALUE(new ValueRunnable()),
    ;

    private final CommandRunnable commandRunnable;

    private RegisteredCommands(CommandRunnable runnable) {
        this.commandRunnable = runnable;
    }

    @Override
    public String toString() {
        return name().toLowerCase();
    }

    /**
     * @return the commandRunnable
     */
    public CommandRunnable getCommandRunnable() {
        return commandRunnable;
    }
}