package ca.recrown.islandsurvivalcraft.interaction.items;

import java.util.ArrayList;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.NamespacedKey;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.entity.HumanEntity;
import org.bukkit.entity.Player;
import org.bukkit.inventory.EquipmentSlot;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.Recipe;
import org.bukkit.inventory.ShapelessRecipe;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.inventory.meta.MapMeta;
import org.bukkit.map.MapCanvas;
import org.bukkit.map.MapRenderer;
import org.bukkit.map.MapView;

import ca.recrown.islandsurvivalcraft.IslandSurvivalCraft;

public class IslandMapItem extends MapRenderer implements VariedItem {
    VariationItemIdentifier identifier;
    NamespacedKey namespacedKey;
    ShapelessRecipe recipe;

    @Override
    public void initialize(IslandSurvivalCraft islandSurvivalCraft) {
        namespacedKey = new NamespacedKey(islandSurvivalCraft, "island_map");
        ItemStack resultItem = new ItemStack(getBaseItem(), 1);
        ItemMeta metadata = resultItem.getItemMeta();
        metadata.setDisplayName(ChatColor.RESET + getName());
        metadata.setLocalizedName(getName());
        metadata.getPersistentDataContainer().set(namespacedKey, identifier, identifier.getID());
        resultItem.setItemMeta(metadata);
        recipe = new ShapelessRecipe(namespacedKey, resultItem);
        recipe.addIngredient(Material.REDSTONE);
        recipe.addIngredient(new ItemStack(Material.MAP));
    }

    @Override
    public void render(MapView map, MapCanvas canvas, Player player) {
    }

    @Override
    public Recipe getRecipe() {
        return recipe;
    }

    @Override
    public String getName() {
        return ChatColor.GREEN + "Island Map";
    }

    @Override
    public Material getBaseItem() {
        return Material.MAP;
    }

    @Override
    public NamespacedKey getNamespacedKey() {
        return namespacedKey;
    }

    @Override
    public void onItemCrafted(ItemStack item, HumanEntity crafter) {
        ItemMeta metadata = item.getItemMeta();
        ArrayList<String> lore = new ArrayList<>();
        lore.add(ChatColor.RESET.toString() + ChatColor.GRAY + "Land ho!");
        metadata.setLore(lore);
        item.setItemMeta(metadata);
    }

    @Override
    public void assignIdentifier(VariationItemIdentifier identifier) {
        this.identifier = identifier;
    }

    @Override
    public VariationItemIdentifier getIdentifier() {
        return identifier;
    }

    @Override
    public boolean needInitialization() {
        return namespacedKey == null;
    }

    @Override
    public boolean onItemRightClicked(ItemStack item, HumanEntity clicker, EquipmentSlot hand, Block block,
            BlockFace blockFace) {
                ItemStack freshMap = new ItemStack(Material.FILLED_MAP, 1);
                MapMeta mapMeta = (MapMeta) freshMap.getItemMeta();

                mapMeta.setDisplayName(ChatColor.RESET + getName());
                MapView mapView = Bukkit.createMap(clicker.getWorld());
                mapView.addRenderer(this);
                mapView.setTrackingPosition(true);

                mapMeta.setMapView(mapView);
                freshMap.setItemMeta(mapMeta);
                clicker.getInventory().setItem(hand, freshMap);
        return false;
    }

    
}