package ca.recrown.islandsurvivalcraft.interaction.items;

import org.bukkit.Material;
import org.bukkit.NamespacedKey;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.entity.HumanEntity;
import org.bukkit.inventory.EquipmentSlot;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.Recipe;

import ca.recrown.islandsurvivalcraft.IslandSurvivalCraft;

public interface VariedItem {
    public void initialize(IslandSurvivalCraft islandSurvivalCraft);
    public Recipe getRecipe();
    public String getName();
    public Material getBaseItem();
    public NamespacedKey getNamespacedKey();
    public void assignIdentifier(VariationItemIdentifier identifier);
    public VariationItemIdentifier getIdentifier();
    public boolean needInitialization();
    public void onItemCrafted(ItemStack item, HumanEntity crafter);
    
    /**
     * Called when this item is right clicked with.
     * @param item The itemstack that was right clicked with.
     * @param clicker The player that did the clicking.
     * @param hand The hand that it was in.
     * @param block The block the item was right clicked on.
     * @param blockFace The face of the block that was clicked.
     * @return
     */
    public boolean onItemRightClicked(ItemStack item, HumanEntity clicker, EquipmentSlot hand, Block block, BlockFace blockFace);
}