package ca.recrown.islandsurvivalcraft.utilities.floodfill;

import ca.recrown.islandsurvivalcraft.utilities.datatypes.Point2;

public interface Floodable {
    /**
     * Called for every block. If it shouldn't be flooded, return false.
     * Code to execute for flooding should be placed here.
     * @param x the x coordinate.
     * @param y the y coordinate.
     * @return if this was a successful flooding.
     */
    public boolean flood(Point2 point);
}